# 17/03/22 Ismail Ilkan Ceylan - The Complexity Landscape of Probabilistic Query Evaluation

## Probabilistic Model

Tuple independent database
- each tuple is associated with a probability value

Can be seen as a way to compute a set of possible worlds.

In every worlds we can pick or not a tuple.

Then we have a probability distribution over the worlds.

The probability of a single world is the product of 
    - the prob of all tuples
    - the complement of the probability of the missing tuples
    
The probability of  a BCQ is the sum of the probability of the worlds the entail the query

-- uses tuple independency
-- closed world (everything missing has 0 prob)


## Complexity class

- #P : (FUNCTIONS??? explain better !) problems recognized by a TM computes the number of accepting computational paths 

#SAT is a canonical example of #P-complete
-- asks to enumerate all solutions !

- PP : langauges recognized by a poly-bounded TM that accepts if >50% accepting computational paths

MAJSAT is a canonical example of PP-complete

## Easy vs Hard queries

Certain queries admit a poly grounding into non overlapping (no shared atoms) queries : compute probability in parallel over them without overestimations (if an atom appears twice this happens)

Hierarchical queries : containement relation on the variables

Separator variable : a variable that produces INDEPENDENT SUBQUERIES

bipartite monotone 2DNF is also #P-hard !
can be used in a reduction to show that Cx xRy Dy is hard

- Small dicothomy query (queries without self-joins)
    - hierarchinal, safe, PTIME
    - non-hierarchical, usafe, #P-hard
- then generalized to UCQ [2013]
    - beyond hierarchical/non hierarchical
    - safe PTIME or unsafe #P-hard
    - covers the self-join case, see ACM paper Suciu and Dalvi providing argument because self-joins kind of generate UCQs 
- even strenghtened to the use of 3 probabilites {0,0.5,1} [2021]

It is decidable to know wether a query is safe or unsafe. 
Upper bound super-exponential (can we be more precise on that?).


## Weighted model counting

- we add a weight on the assignments

- we can establish a correspondence between weighted model counting (WMC) and proba tup ind database (PDB)

important message : we can transfer results from WMC to PDB

- weighted DNF counting has an approximation scheme, but this approximation is NP-hard

## Probabilistic OMQ

extension of the PDB model to OMQA

compute proba over all possible worlds

computationnaly more difficult because of the new entailments

Cx ^ xRy -> Cy is already #P-hard
can be used to encode a source-to-target reachability


## Homomorphism closed queries

nice idea : can see a homomorphism closed query (HCQ) as an infinite union of CQs !

if we see them from the abstract way it is easy to see for example that such queries can allow one to write "there is a path of prime lenght". Then finding the concrete program that does so is another thing.

Theorem [2022]
unbouded HCQ over are #P-hard

together with the results of Suciu and Dalvi (bounded HQC), this gives a whole dichotomy for HCQ.

open question : how to recognize safe and usafe queries for HCQ ?

## Open questions

implementations



Question : are these complexity notions enough for studying probabilistic queris with rules ? do we need other complexity notions ?

- Ismail : to go fine grain, better to go with the classes that are approximable 



What about the hypothesis on the data ? for instance I am running a reachability query over a path ?

- see the work of Antoine Amarilli, that shows the tractability for tree like data