### 30/09/2021 - Interface Phyton pour Graal

#### Documentation : <https://gite.lirmm.fr/graphik/graal-group/graal/-/blob/Stage-Salembien/README.md>

#### Questions

* Fede : que se passe-t-il si l'on a plein de substitution (très grande chaîne de caractères) à renvoyer vers Phyton ? 
  * déconseillé --> mieux de passer par des itérations, et paginer éventuellement 
* Mada : si l'on a un gros fichier à charger 
  * mieux envoyer le chemin vers le fichier à tester
* Tests ?
  * Testé pour l'instant sur la base du Titanic. Des milliers des réponses (vérifier) temps raisonnable. Peut on préciser ?
* ML : Projet fini ?
  * pas encore, manque encore la manipulations de certains objets (règles)
* ML : quelle portée ? que du requêtage ?
  * requêtage + Kiabora 
* Fede : compatibilité prévue avec Graal v2 ?
  * voir le point sur 
* ML : pourquoi Phyton si on faisait un interpréteur en ligne de commande ?
  * Phyton plus expressif et intègre plein d'autres fonctionnalités
* ML : pourquoi ne pas faire l'interpréteur en ligne de commande directement dans Graal
  * Architecture plus complexe, invite à mieux penser aux besoins utilisateurs 
  * Ca permet aussi de gérer plusieurs KB
* Fede : lien avec BRunner ?
  * Penser aux fonctionnalités qu'on veut exposer et les faire correspondre aux tests qu'on veut permettre.

#### Notes

Proposer une syntaxe phyton très succinte pour manipuler le logiciel.

1. py4j - pont Phyton / Java

* permet de créer une machine virtuelle Java
* lancer un serveur Graal
* établir un gateway pour la communication/connexion (...import JavaGateway)

2\. Communication

* on ne peut pas manipuler des types complexes 
  * phyton vers java : DLGP, nom de fichiers
  * java vers phyton : on met les substitutions dans du JSON (vu comme une chaîne de caractères)
* alors comment donner l'impression de manipuler des objets Java dans phyton ? (notamment une KB)

3\. Objets "virtuels" en phyton

* the trick : on garde du côté serveur graal un id pour les objets qu'on veut rendre virtuels
* du coup, à chaque fois, on passe cet identifiant phyton-->Java et on saura dans quelle KB faire nos manipulations (il faut aussi le connecteur)

4\. Énumérations

* les ResultSet du côté Java sont gérés d'une façon similaire. Un identifiant pour un iterateur est gardé au niveau serveur, et puis à chaque fois on l'incremente
* important : du côté Phyton, il faut implémenter les méthodes "iter" et "next" pour pouvoir itérer

5\. Au déla de Phyton

Code modulaire du côté Java. 

Permet de brancher autres choses que Phyton.

Par exemple, avoir un interpreteur en ligne de commande (c'était prévu mais pas fait). 

6\. Conclusion : module commun à toutes les sur-couches de Graal ?

* Cogui, ...

Réflexion (au niveau d'équipe) sur les fonctionnalités qu'on offrirait. 

7\. Fusion des stages de Rihad et Tom

* peut on faire appel à des fonctions Phyton depuis Java ? si c'est le cas on peut avoir les filtres de Rihad sans demander à l'utilisateur de coder ses fonctions en Java
  * pour python 2, voir Jython qui compile du code Python en bytecode de la jvm
  * pour Python 3, Guillaume et Florent ont fait un proof of concept lançant un seul processus Python avec lequel communique graal via l'entrée et la sortie standard (on passe sur l'entrée standard le nom du fichier, le nom de la fonction à appeler et ses paramètres et le processus Python s'occupe de retourner le résultat sur sa sortie standard) (cf <https://seafile.lirmm.fr/smart-link/d37a12e3-85f1-4eaa-82a3-683d969763d0/>)


