## 21/10/28 C. Sipieter - Outils et projets Anabasis

Projets en cours de l'entreprise.

Reprise Docamex par Anabasis: projet en bonne voie

Discussions (toujours Anabasis) avec Abes pour reprise Qualinca

### Problématiques rencontrées par Anabasis

### Kalamar : langage de règles d'Anabasis

* important pour des applications d'avoir des filtres et prédicats built-in (eg, age >= 18)
* question d'utiliser des bibliothéques existantes
* agrégats : stratification pour être sur d'avoir calculé tous les atomes à agréger
* stockage : triplestore Jena + règles Jena
  * question : triplestore en mémoire vive ou secondaire ?
* sucre syntaxique 
  * des property paths p1/p2
  * factoriser les règles avec des if imbriqués
* contraintes positives sous forme de test qui soulèvent des warnings
  * on indique avec les contraintes négatives par quelque chose qui rend la base incohérente
* question ML : a-t-on le moyen d'indiquer si le résultat d'une interrogation est une variable (ou noeud blanc) ou une constante?
  * C: pas de vraie notion de variable/noeud blanc : à expliquer
* $ ex:fatherOf ?x 
  * on crée un constante à la place d'un existentiel 
    * Fede : mais je n'ai pas compris comment cette constante est crée
      * on fait appel à la fonction MakeSkolem de Jena
        * <https://jena.apache.org/documentation/javadoc/jena/org/apache/jena/reasoner/rulesys/builtins/MakeSkolem.html> 
    * Michel : comment gêre-t-on des règles avec plusieurs variables en conclusion
      * on Skolemise et on décompose en tête atomique
    * Fede : cas d'utilisation ?
      * échange de messages entre systèmes opérationnels
      * on se sert de l'existentiel pour créer une structure manquante lorsqu'on change le format d'un message
* requêtes SPARQL
* types de données en entrée

Cas de l'import des données XML 

* Traduction XML -> RDF 
  * Fede : pas compris les détails... c'est une arborescence XML qui dévient un graphe (arbre) RDF ?
  * c'est une sorte de mapping
    * observation de Clément, contrairement aux règles, dans les mappings il n'y a pas de métier
* JF : quels types de requêtes ?
  * pas vraiment des requêtes on veut plutôt faire de la traduction d'un jeu de donnés dans un format A vers un format B
  * qui définit le format du message XML ?
    * Fede : j'ai perdu la réponse...
* David : a-t-on des règles récursives ?
  * Clément : dans la problématique de traduction non, mais dans un autre projet oui
    * exemples ?
* David : pourquoi utiliser les règles (question générale) ? pourquoi ne pas tout encoder dans un programme Javascript?
  * Clément 
    * modularisation et réutilisation du code : plus compréhensible et mieux maintenable dans le temps
    * logique pour raisonnements
    * exploiter le format graphique pour aider la compréhension des traitements
      * Karnyx
      * Clément : mix entre notation graphes conceptuels et UML
    * débogage : exploitation du GRD pour anticiper l'impact de certaines opérations
      * modifier la règle X impacte les concepts Y
      * anticiper le déclanchement de contraintes négatives
      * redondance des calculs
* JF : qu'est ce que les clients veulent voir dans les applications ?
  * C : cela dépende des applications
    * pour le cas des systèmes communicants on veut boîte noire qui fait des traductions d'un format vers l'autre
      * fournir à la fin un fichier  (excel, XML, autre) que le système cible est capable de lire (sans besoin d'intervention humaine)
* Fede : syntaxe pour les prédicats n-aires?

### Interrogation et consolidation de sources hétérogènes

* inclut des problématiques de liage des données
  * retrouver les codes des composants (eg, pales d'hélicoptère)
    * sont dans un même chapitre ou sous-chapitre du catalogue
    * désignations, libellés
    * autres informations

liage est un use-case intéressant (et bien connu) pour les règles

* JF : quid de la réutilisation d'un liage précédent lorsqu'on fait un nouveau liage ?
  * C : on n'a pas eu le droit à cette information

### Classification avec des règles expertes et apprises

2% de contradictions.

Le projet s'est arrêté du côté d'Anabasis.

**En conclusion** : les projets en cours d'Anabasis sont DOCAMEX, ABES, et liage pour des pièces aeronautiques. 

Le projet sur la traduction automatique est en stand-by. De même celui sur la classification des dépenses. 

### Présentation de Florent

* Clément : quelle syntaxe pour les mappings ? c'est un vraie question
  * Implémentation du côté Anabasis (compléter)
* Virtualisation : important d'avoir des alternatives à la saturation 

JF : 

* quelles sont les limites de Jena ?
  * C : solution par défaut ; assurait le passage à l'échelle ; Graal n'avait pas le système de built-in (très important)
  * C : limite de jena c'était de ne pas avoir la négation, qui a été codée dessus
  * Jena permette de faire de la marche arrière ; et aussi de l'hybridation (marche avant/arrière)
    * pas clair (vérifier la doc)
    * mais ce n'est pas une feature utilisée ici 
* qu'est ce qu'un autre moteur de raisonnement pourrait donner ?
  * probabilités pour les problèmes de liage
  * temporel
  * outils d'analyse du modèle pour détecter des redondances/incohérence dans les règles
    * création d'un plan d'exécution des requêtes pour l'optimisation du chase
    * détection des redondances : stage Julien
    * afficher le GRD pour voir les dépendances
      * Il existe un prototype sur Graal permettant d'afficher le GRD
    * complétion : voir les inférences déclenchées par l'application de la règle 
      * la tête est H, mais en réalité c'est Sat(H)
        * distinction entre applications sûres et possibles
      * dans tout cas, c'est un outil pour les utilisateurs experts
  * limitation de Jena : les built-in ne peut renvoyer qu'un seul résultat
  * regex
    * regex("cab", "(._)a(._)", ?idx, ?val)
    * Pour récupérer les groupes, on veut 2 réponses : 1 -> c ; 2 -> b
* qu'est ce qui manque dans Graal ?
    

**Conclusion**

Sudocal : reconnaitre la contribution de l'équipe dans le développement des projets

* cela intéresse aussi au lirmm
* envisager des stages et projets ANR / bilateraux



Côté Anabasis :  peut être un jour on aura besoin d'un nouveau moteur de règles comme Graal (eg cas aéronautique) mais il ne s'agit pas d'un besoin pressant pour l'instant  

Michel : collaboration avec Anabasis (analyse/affichage GRD, analyse redondances/règles directement appliquées) 




